const createHttpRequest = require('./http-request')
const pipeThrough = require('./middleware')
const createHttpResponse = require('./http-response')

const middleware = []

module.exports.use = fn => {
  middleware.push(fn)
}

module.exports.httpHandler = (httpRequest, httpResponse) => {
  const { onResolved, onRejected } = createHttpResponse(httpResponse)

  createHttpRequest(httpRequest)
    .then(pipeThrough(middleware))
    .then(onResolved)
    .catch(onRejected)
}
